
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
import pyNN.spiNNaker as sim

from compoundPlanClass import PlanClass

RUN_DURATION = 400
#initialize the simulator. 
def init():
    sim.setup(timestep=neal.DELAY, min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

def createInputs():
    inputSpikeTimes0 = [10.0]
    inputSpikeTimes1 = [250.0]
    
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')
    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
                                   label='inputSpikes_1')

    return [spikeGen0,spikeGen1]

    

#---main 
simName = "spinnaker"
spinnVersion = 8

neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
init()
planner = PlanClass(simName,sim,neal,spinnVersion,fsa)
planner.connectCompoundPlanner()

spikeGenerators = createInputs()
firstSpikeGenerator =  spikeGenerators[0]
secondSpikeGenerator =  spikeGenerators[1]

planner.testSetGoal(planner.goalForwardAndRight,firstSpikeGenerator)
planner.testSetGoal(planner.goalForwardAndLeft,secondSpikeGenerator)

neal.nealApplyProjections()
sim.run(RUN_DURATION)

planner.printResults()
