"""
Just test the initial state.
"""

import pyNN.spiNNaker as sim

from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from cogmapClass import cogmapBaseClass

def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

def makeSpikeSource(inputTimes):
        inputSpikeTimes1 = inputTimes
        spikeArray1 = {'spike_times': [inputSpikeTimes1]}
        spikeGen1=sim.Population(1,sim.SpikeSourceArray,spikeArray1,
                                   label='inputSpikes_1')

        return spikeGen1

#------------Main Body---------------
simName = "spinnaker"
spinnVersion = 8

neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)

init()

cogmap = cogmapBaseClass(simName,sim,neal,spinnVersion,fsa)
#build the cogmap
cogmap.createObjects(2)
cogmap.connectObjects()
cogmap.createPlaces(3)
cogmap.connectPlaces()
cogmap.setupCogMapRecording()
cogmap.makeLearningSynapses()
cogmap.connectAutomaton()

spikeSource = makeSpikeSource(10.0)
cogmap.sourceStartsAutomaton(spikeSource)

neal.nealApplyProjections()
sim.run(200)

cogmap.printCogMapNets()
sim.end()
